/* 
	Class qui permet l'change des donnes avec le serveur
		*Envoi de requte check (pour vrifier le support de perseus)
		*[option] Envoi de requte known pour connatre si le 
					serveur  le codeur
		*Codage des donnes
		*Envoi des donnes codes
*/


#ifndef _nsPerseusUploadata_H_
#define _nsPerseusUploadata_H_

#include "nsPerseusUtil.h" 
#include "nsIChannel.h"
#include "nsPerseusCode.h"
#include "nsStringAPI.h"

#include "nsISeekableStream.h"

enum TypePost{
    MimeType,
    StringType
};

class PerseusUploadData
{
public:
  PerseusUploadData( nsIChannel *aChannel, nsPerseusCode *aCode) ;
  virtual ~PerseusUploadData();
  nsresult check();
  nsresult readDataPost();
  nsresult readDataGet(nsIURI* uri);
  nsresult sendOriginal();
  nsresult sendCoded();

protected:
  nsCOMPtr<nsIChannel> mChannel;
  nsresult  sendParameters(const nsACString& host);
  nsresult  checkContent();

private:
  nsPerseusCode * mPerseusCode;
  nsCOMPtr<nsIInputStream> mStream;
  nsCString mData;
  nsCString mMethod;
  nsCString mContentType;
  TypePost  mTypePost;
  PERSEUS_CTYPE_t   mEncType;
  PRUint32	mSizeBody;
  nsCString mHost;
  nsresult readContentMime();
  nsresult readContentString();
  nsresult readBody(nsISeekableStream* seekableStream);
  
};

#endif //_PerseusUploadData_H
