/* TODO : UPGRADE vers la Libperseus
*/

#include "nsPerseusUtil.h"
#include "nsPerseusCode.h"

#include "nsISupports.h"
#include "nsStringAPI.h"

#include "math.h"

#include "prmem.h"
#include "prrng.h"
#include "prlong.h"
#include "prprf.h"

/*#define number {\
      0x8A914C0804621A14,\
      0x914A014085241543,\
      0xA04281A49A023510,\
      0x104850915C10982C,\
      0x4485A04212305138,\
      0x31A0482C81234508,\
      0x19024D0410C123A1,\
      0x84A21115C6140105,\
      0x4502618C13156840,\
      0x3241C2034898C141\
}*/


#define alea() \
  (rand()/(RAND_MAX + 1.0))

/*****************************************************************************
 * Function to manage string
 *
 ****************************************************************************/

/*** int_to_char : transform a integer array to a string. 
 *      Each integer has k bits
 **/
char *
int_to_char(PRUint32 * aTab,
        PRUint64 aLength,
        PRUint8 k)
{
    PRUint16 r,i;
    PRUint64 j,n;
    PRUintn size=(PRUintn) ceil((float) (aLength*k/8.0));
	LOG(("Perseus Extension : [Int_to_char] %u bytes in data decoded",size));
    char * data = (char *) NS_Alloc(sizeof(char)*size);
	for (i=0;i<size;i++)
		data[i]=0;
    if (k==8) {
        for(i=0; i<size;i++)
            data[i]=aTab[i];
    }
    else
    {
        i=0;
        j=LL_Zero();
        n=LL_Zero();
        while(1)
        {

            for(r=0;r<8;r++) {
                if(i==k) {
                    if(++n==aLength) {
						LOG(("Perseus Extension : [Int_to_char] Data decoded : %s",data));
						data[j]='\0';
                        return data;
                    }
                    i=0;
                }
                data[j] |= ((aTab[n]>>(i)) &0x1)<<r;
                i++;
            }
            j++;
        }
    }
    data[size]='\0';
    return data;
}

/**** char_to_bin : transforms a string to a array of bits 
 *      size array must be a multiple of aK 
 *          and ends with aK*aN zeros
 ****/
nsresult
char_to_bin(const char * aData,
        PRUint64 aLength,
        PRUint8 aK,
        PRUint8 aN,
        char ** aDataBin,
        PRUint64 * aNewLength)
{
    PRUint8 Length_car=8;
    PRUint8 j;
    PRUint64 i;
    PRUint64 k=0;
    PRUint16 l;
    PRUint16 bour= (aK - ((aLength*Length_car) % aK)) % aK;
     LOG(("[Perseus Extension] - \
		 [char_to_bin]  data to transform : %s",aData));

	
	bour= bour +(aK*aN);
    *aDataBin= (char *) NS_Alloc(sizeof(char) * (aLength*Length_car)+bour);
    if (!aDataBin)
        return NS_ERROR_FAILURE;
    for(i=0;i<aLength;i++) {
        for(j=0;j<Length_car;j++)
            (*aDataBin)[k++]= (aData[i] >> j) &0x01;
    }
    for(l=0;l<bour;l++)
        (*aDataBin)[k++]=0;
    *aNewLength=k;
	for (i=0;i<k;i++)
		 LOG(("%d",(*aDataBin)[i]));

    return NS_OK;
}


/* hex_to_Binchar transform a string in Hexa
 *  in a array of bit.
 *      e.g. AB18 ==> 1|0|1|0|1|0|1|1|0|0|0|1|1|0|0|0
 * the first integer of aDataHex is the length of the last
 * hexa. symbol
 *  eg the first bit is 3 then the last hexa symbol 4 
 *      is 010
 *  EG : 3AB184 ==> 1|0|1|0|1|0|1|1|0|0|0|1|1|0|0|0|0|1|0
 *  */
void
hex_to_Binchar(char * aDataHex,
        PRUint64 aLength,
        char ** aDataBin,
        PRUint64 * aDataBinLength)
{
    PRUint64 i;
    PRUint8 j;
    PRUint8 tmp;
    PRUint8 rest=aDataHex[0] -'0';

    *aDataBinLength=0;
    if (aLength <= 1)
    {
        *aDataBin=NULL;
        return;
    }

    *aDataBin=(char *) NS_Alloc(sizeof(char)*((aLength-1)*4));

    for(i=1;i<aLength-1;i++) {
        if ('0' <= aDataHex[i] && aDataHex[i]<= '9') {
            tmp=aDataHex[i]-'0';
        } else if ( 'A'<= aDataHex[i] && aDataHex[i]<= 'F') {
            tmp=aDataHex[i] - 'A'+ 10;
        }
        for(j=0;j<4;j++) 
            (*aDataBin)[(*aDataBinLength)++]= (tmp>>(3-j)) &0x1;
    }
    /*Last Hex symbol */
    if ('0' <= aDataHex[aLength-1] && aDataHex[aLength-1]<= '9') {
        tmp=aDataHex[aLength-1]-'0';
    } else if ( 'A'<= aDataHex[aLength-1] && aDataHex[aLength-1]<= 'F') {
        tmp=aDataHex[aLength-1] - 'A'+ 10;
    }
    for(j=0;j<(4-rest);j++) 
            (*aDataBin)[(*aDataBinLength)++]= (tmp>>(3-j)) &0x1;
}


/*hex to char*/
/* return -1 error*/
char 
htoc(unsigned char hex)
{
    if ( hex>=0 && hex<=9)
        return hex+'0';
    if ( hex>9 && hex<=15)
        return hex+'A'-10;
    return -1;
}

/*  bin_to_charHex transform a array of bit
 *  in a string in Hexa
 *      e.g. 1|0|1|0|1|0|1|1|0|0|0|1|1|0|0|0 ==> AB18 
 * the first integer of aHexData is the length of the last
 * hexa. symbol
 *  eg the first bit is 3 then the last hexa symbol 4 
 *      is 010
 *  EG : 1|0|1|0|1|0|1|1|0|0|0|1|1|0|0|0|0|1|0  ==>  3AB184 
 */

void
bin_to_charHex(char * aBinData,
               PRUint64 aLength,
               char ** aHexData,
               PRUint64* aHexDataLength)
{
    PRUint64 i,k;
    PRUint8 j=0,tmp=0;
   
   // *aHexDataLength=0;
    //*aHexData = (char *) PR_Calloc(sizeof(char),1);
    LOG(("aLength : %u; aLength<<2 : %u, aLength/4:%u, rest %u",aLength,aLength>>2,aLength/4,aLength % 4));
   // PRUint8 mod = aLength % 4;

    *aHexData = (char *) PR_Calloc(sizeof(char),(aLength/4.0)+1+1+1);
    
    //if (!mod) 
    //    mod = 4;
	//LOG(("Mod : %u",mod));
    //**aHexData = mod + '0';
	//(*aHexData) = PR_sprintf_append(*aHexData,"%X",mod);
    //(*aHexDataLength)++;
    k=1;
    for(i=0;i<aLength;i++) {
        tmp<<=1;
        tmp|=aBinData[i]&1;
        j++;
        if (j==4) {
            j=0;
			LOG((" hex : %X",tmp));
            //(*aHexData) = PR_sprintf_append(*aHexData,"%X",tmp);
            (*aHexData)[k] = htoc(tmp);
            k++;
            tmp=0;
        }   
    }
    if (j==0) {
        (*aHexData)[0]='0';
    }
    else {
        (*aHexData)[0]='0'+(4-j);
        while(j < 4) {
            j++;
            tmp<<=1;
        }
        (*aHexData)[k]=htoc(tmp);
        k++;
    }
     (*aHexData)[k]='\0';
    *aHexDataLength=k;

}

/*PRUintn *
charBin_to_int(const  char * aData,
        PRUint64 aLength,
        PRUintn n,
        PRUintn * size)
{
    *size=(PRUintn) (aLength/n);

    PRUintn * tab= (PRUintn *) NS_Alloc(sizeof(PRUintn)*(*size));
    PRUintn i,j,t=0;

    for(i=0;i<*size;++i) {
        tab[i]=0x00;
        for(j=0;j<n;++j) {
            tab[i]<<=1;
            tab[i] |= (aData[t]-'0');

            t++;
        }
    }
    return tab;
}
*/

/*********************************************************************************
 *                      Noise Functions
 ********************************************************************************/
/* noise :
 * in :
 *      aReg integer 64 bit 
 *      aNumLine : a line number  0<=aNumLine<10
 * out :
 *      return a bit in index[aNumline]
 */
inline PRUint8
noise(PRUint64 aReg, PRUint8 aNumLine)
{
   PRUint64 index[10] = { LL_INIT(0x8A914C08,0x04621A14),
      LL_INIT(0x914A0140,0x85241543),
      LL_INIT(0xA04281A4,0x9A023510),
      LL_INIT(0x10485091,0x5C10982C),
      LL_INIT(0x4485A042,0x12305138),
      LL_INIT(0x31A0482C,0x81234508),
      LL_INIT(0x19024D04,0x10C123A1),
      LL_INIT(0x84A21115,0xC6140105),
      LL_INIT(0x4502618C,0x13156840),
      LL_INIT(0x3241C203,0x4898C141)};
   
   /* 0 <= I <= 63 */
    PRUint8 I = (aReg>>33) & 0x3F;
    return ((index[aNumLine]>>I) & 0x1);
}

/* sumbit : 
 *  in : 
 *      w=w0w1w2...w63
 *  out :
 *      w0^w1^...^w63
 */
inline PRUint8
sumbit(PRUint64 w)
{
    w ^= w>>32;
    w ^= w>>16;
    w ^= w>>8;
    w ^= w>>4;
    w ^= w>>2;
    w ^= w>>1;
    return (w & 0x1);
}

/* * random()
 */
inline void 
random(PRUint64* aPol, PRUint64* aReg)
{
    PRUint8 rebouclage;
    PRUint8 i;
    PRUint64 tmp;
    for(i=0;i<64; i++) {
        /*sumbit compute the sum of bits in GF(2) */
        rebouclage = sumbit((*aReg) & (*aPol));
        *aReg = *aReg>>1;
        tmp = rebouclage;
        *aReg = (*aReg) | tmp<<63;
    }
 //   return aReg;
}


/* addNoise
 * in :
 *     aData a array of bit
 *     aLength : array size
 * out :
 *     aData a array of bit with noise
 *
 */
nsresult
PCC::addNoise(char * aData, PRUint64 aLength)
{
    /*
		LOG(("[Perseus Extension] - \
                [PCC::addnoise]  \
                [mX0,mNumLin] : [%u,%u]",mX0, mNumLin));
	*/
    PRUint64 reg=mX0;
//LOG(("x0 %llu",mX0));
    PRUint64 P =  LL_INIT(0x80000000,0x0000FFF9);
//LOG(("P %llu",P));
    PRUint8 Et;
    PRUint64 i=0,r=0;
    //PRTime z,z1;

    /*add noise in aData*/
    for(i=0;i<aLength;i++) {
         /*reg is a 63 bits random integer*/
       //  z=PR_Now();
        random(&P,&reg);
       //  z1=PR_Now();
        //   LOG((" noise Temps de random : %lu",z1-z));
//LOG(("reg %llu",reg));
        /*noise generates 1 bit which has 30% chance to be a one*/
       //  z=PR_Now();
        Et = noise(reg,mNumLin);
        // z1=PR_Now();
         // LOG((" noise Temps de noise : %lu",z1-z));

        /* the noise is applied to the stream */
        aData[i]^=Et;
        r++;
    }
    return NS_OK;
}


/*****************************************************************************
 ***   PCC Class
 ***
 ****************************************************************************/
PCC::PCC()
{}

PCC::~PCC()
{
    LOG(("Running... delete PCC"));
    PRUint8 i;

    for(i=0;i<mK;i++)
        NS_Free(mPoly[i]);
    NS_Free(mPoly);
    NS_Free(mMatrix);
}

/*Generate PCC parameters : n,k,M,Matrix P, Poly.
 * And noise parameters : X0, numLine*/
nsresult
PCC::generateCode()
{
    PRUint64* buf = ( PRUint64*) NS_Alloc(sizeof(PRUint64));
    if (!buf) 
        return NS_ERROR_OUT_OF_MEMORY;

    PR_GetRandomNoise(buf,8);
    srand(buf[0]);
    NS_Free(buf);
    //Generate a ID
    mID=rand()% (1<<16);
    
    while( (mN=rand()% KMAX_GEN) <4);

    do {
        mK=rand()%KMAX_GEN;
    }while( (mK<1) || (mK>=(mN-2)) );

    while( (mM=rand()% MAX_CONT) <MIN_CONT);

    mX0 = rand();
    mNumLin = rand() %10;

    while ( (mMatWidth = rand()% KMAX_GEN) <3);

    PRUint16 i,j,k;
    unsigned int  nbzero = (int)((float)(mN*mMatWidth/8.0));
    
    
    mMatDepth = (mN*mMatWidth) - nbzero;

    unsigned int index;

    mMatrix=(PRUint8 *) NS_Alloc(sizeof(PRUint8 ) * (mMatWidth*mN));
    if(!mMatrix)
        return NS_ERROR_OUT_OF_MEMORY;

    for (i=0;i<(mMatWidth*mN);i++) {
        mMatrix[i]=1;
    }
    
    while (nbzero) {
        index = (int)((float)(mMatWidth * mN)*alea());
        if (index<=mN)
            continue;
        if (mMatrix[index]) {
            mMatrix[index] = 0;
            nbzero--;
        }
    }

    LOG(("[Perseus Extension] - [PCC::generateCode] PCC Parameters \
                [n,k,m,MatrixWidth,MatrixDepth] : [%u,%u,%u,%u,%u]",
                mN,mK,mM,mMatWidth,mMatDepth));

    mPoly=(PRUintn **) NS_Alloc(sizeof(PRUintn *) * mK);
    if(!mPoly)
        return NS_ERROR_OUT_OF_MEMORY;

    PRUint32 maxPoly=(1<<(mM+1));

    for(i=0;i<mK;i++) {
        mPoly[i] =(PRUintn *) NS_Alloc(sizeof(PRUintn) * mN);
        if (!mPoly[i]) {
            for(k=0;k<i;k++)
                NS_Free(mPoly[k]);
            return NS_ERROR_OUT_OF_MEMORY;
        }
        for(j=0;j<mN;j++)
            while( (mPoly[i][j]=rand() % maxPoly) <1);
    }    
    LOG(("[Perseus Extension] - [PCC::generateCode] PCC Parameters \
                [n,k,m,MatrixWidth,MatrixDepth,mX0] : [%u,%u,%u,%u,%u,%u]",
                mN,mK,mM,mMatWidth,mMatDepth,mX0));
    return NS_OK;
}

 /*
  * Pcc and noise parameters to string
  */
char *
PCC::toString()
{
    PRUint8 i,j;

      LOG(("[Perseus Extension] - [PCC::toString] Start")); 
    char* param = PR_sprintf_append(0,"%u\r\n%u\r\n%u\r\n",mN,mK,mM);
    for(i=0;i<mK;i++) {
        for(j=0;j<mN;j++)
            param=PR_sprintf_append(param,"%u\r\n",mPoly[i][j]);
    }

      LOG(("[Perseus Extension] - [PCC::toString] middle")); 
    param=PR_sprintf_append(param,"%u\r\n",mMatWidth);

    for(i=0;i<mMatWidth*mN;i++) {
        param=PR_sprintf_append(param,"%u\r\n",mMatrix[i]);
    }
      LOG(("[Perseus Extension 0.1b] - [PCC::toString] Pcc parameters : \
       \n%s",param));
   param=PR_sprintf_append(param,"%u\r\n%u\r\n",mNumLin,mX0);
    //param=PR_sprintf_append(param,"%u\r\n",mID);
  return param;
}

/*
 * Puncture : delete symbols following the pattern mMatrix
 * in :
 *      aStream : a array of bits
 *      aLength : array size 
 *  out :
 *      aNewStream : a array of bits punctured
 *      aNewLength : size of aNewLength (aNewLength<=aLength)
 */
nsresult 
PCC::puncture(char * aStream, PRUint64 aLength,
			  char ** aNewStream, PRUint64 *aNewLength)
{

    PRUint64 i;
    PRUint8 j=0;
    *aNewLength=0;
    *aNewStream=(char *) NS_Alloc(sizeof(char) * aLength);

    for(i=0;i<aLength-1;i++) {
        if (j == mMatWidth*mN) {
            j=0;
        }
        if (mMatrix[j]) {
            (*aNewStream)[*aNewLength]=aStream[i];
            (*aNewLength)++;
        }
        j++;
    }
    
    (*aNewStream)[*aNewLength]=aStream[aLength-1];
    (*aNewLength)++;

    return NS_OK;
}

/*
 * Unpuncture : add symbols following the pattern mMatrix
 * in :
 *      aStream : a array of bits punctured
 *      aLength : array size 
 *  out :
 *      aNewStream : a array of bits unpunctured 
 *          (unpuctured symbols are marked with 0xF)
 *      aNewLength : size of aNewLength (aNewLength>=aLength)
 */
nsresult 
PCC::unpuncture(char * aStream, PRUint64 aLength,
        char ** aNewStream, PRUint64 *aNewLength)
{
    PRUint64 i;
    PRUint8 j=0;
    *aNewLength=0;
    *aNewStream=(char *) NS_Alloc(sizeof(char) * (aLength+((aLength/(mN*mMatWidth-mMatDepth)+1)*mMatDepth)));
    i=0;
    while(i<aLength) {
        if (j==mMatWidth*mN) {
            j=0;
        }
        if(!mMatrix[j])
            (*aNewStream)[*aNewLength]=0xF;
        else {
            (*aNewStream)[*aNewLength]=aStream[i++];
        }
        (*aNewLength)++;
        j++;
    }
    return NS_OK;
}


 /*
  * Compute : compute N ouput bits
  * in : 
  *     aPoly : N polynom
  *     aBit  : a bit that represent a k-th entry
  *     aMemory : the k-th memory 
  * out :
  *     value : a integer which represents N ouput bits
  *     |vNvN-1...v1v0|
 */ 
void
PCC::compute(PRUintn * aPoly,
        PRUint8 aBit,
        PRUint32 aMemory,
        PRUint16 *value)
{
    PRUint8 i,j;
    PRUint8 pol;
    PRUint8 val=0;
    for(i=0;i<mN;i++) {
        pol=aPoly[i]&1;
        val=pol&aBit;

        for(j=1;j<=mM;++j) {
            pol=(aPoly[i]>>j)&1;
            val^=pol&(aMemory>>(j-1));
        }
        *value<<=1;
        *value|=val;
    }
}

/* Code data with a PCC
 * in : 
 *      aData : a string 
 *      aLength : data length
 *  out :
 *      aDataCoded : data coded with a pcc
 */
nsresult 
PCC::code(const nsACString & aData,
                   PRUint64 aLength,
                   nsACString & aDataCoded)
{
    PRTime z,z1;
    z=PR_Now();
  
   if (aLength==0) 
        return NS_ERROR_FAILURE;
    LOG(("[Perseus Extension] - \
                [PCC::code] PCC Parameters \
                [n,k,m,MatrixWidth,MatrixDepth] : [%u,%u,%u,%u,%u] \n Taille donnée : %lu octets" 
                ,mN,mK,mM,mMatWidth,mMatDepth,aLength));
    PRUint64 binsize;
    char * databin;
    PRUint64 i,length_output;
    PRUint8 k; 
    PRUint8 abit;
    PRUint16 value=0, tmpvalue=0;

    PRUint32 * memory= (PRUint32 *) PR_Calloc(sizeof(PRUint32),mK);
    if (!memory) 
        return NS_ERROR_OUT_OF_MEMORY;
    /* Bitmask is a mask to manage memory*/
    PRUint32 bitmask=0;
    for(i=0;i<mM;++i) {
        bitmask <<= 1;
        bitmask |= 1;
    }
    /* string to a array of bits */
    char_to_bin(ToNewCString(aData),aLength,mK,mN,&databin,&binsize);
    LOG(("[Perseus Extension] - "
         "[PCC::code] Length of data to code in binary: %lu", binsize));

   /*valueFin is a array of bit which represents ouput symboles*/
    char * valueFin=(char *) NS_Alloc(sizeof(char)*(mN*binsize));
    if (!valueFin) 
        return NS_ERROR_OUT_OF_MEMORY;
    i=0;
    length_output=0;
     PRTime z2;
    z2=PR_Now();

    while(i<binsize) {
        for(k=0;k<mK;++k) {
            if(i>=binsize)
                break;
            abit=databin[i++]&0x1; 
            this->compute(mPoly[k],abit,memory[k],&tmpvalue);
        //    LOG(("compute : bit %u",abit));
            memory[k]=(memory[k]<<1 | abit)&bitmask;
            value^=tmpvalue;
            tmpvalue=0;
        }
          //  LOG(("compute : sortie %u",value));
        for(k=0;k<mN;k++) 
            valueFin[length_output++]=value>>(mN-k-1) &0x1;
        value=0;
    }
    PRTime z3;
    z3=PR_Now();
    LOG((" Before puncture "));

	for (i=0;i<length_output;i++)
  LOG(("%d",valueFin[i]));
    /*
	LOG(("[Perseus Extension] - \
                [PCC::code] Coding End taille donnée codée : %//u",length_output));
*/
    char * nstream=0;
    PRUint64 nsize;
    z2=PR_Now();
    puncture(valueFin,length_output,&nstream,&nsize);

      z3=PR_Now();
        LOG((" Temps de puncture : %lu",z3-z2));
    LOG(("[Perseus Extension] - \
                [PCC::code] Length after puncture %lu",nsize));
for (i=0;i<nsize;i++)
  LOG(("%d",nstream[i]));
   

  z2=PR_Now();
   addNoise(nstream,nsize);
 
/*LOG(("[Perseus Extension] - \
                [PCC::code] Length after noise %lu",nsize));
  */
     z3=PR_Now();
  LOG((" Temps de noise : %lu",z3-z2));
for (i=0;i<nsize;i++)
  LOG(("%d",nstream[i]));
    char * Hexstream=0;
    PRUint64 Hexsize;
    bin_to_charHex(nstream,nsize,&Hexstream,&Hexsize);
    LOG(("[Perseus Extension] - \
                [PCC::code] data coded in hex %s",Hexstream));

	
	aDataCoded.Assign(Hexstream);
    
    if (nstream)
        NS_Free(nstream);
    if (valueFin)
        NS_Free(valueFin);
    if (memory) 
        NS_Free(memory);
    z1=PR_Now();
    LOG((" Temps de total codage : %lu",z1-z));
    return NS_OK;
}
/* decode data with a PCC
 * in : 
 *      aData : a string coded 
 *      aLength : data length
 *  out :
 *      aDataCoded : data decoded with a pcc
 */
nsresult
PCC::decode(const nsACString & aDataCoded,
        PRUint64 aLength,
        nsACString & aData)
{
    PRTime z,z1,z2,z3;
    z=PR_Now();

    //LOG(("We start decoding"));
    char * adata=ToNewCString(aDataCoded);
   // LOG((" hex : %s, hexsize : %u ",adata,aLength));
    char * databin;
    PRUint64 binsize;
    hex_to_Binchar(adata,aLength,&databin,&binsize);
   // LOG(("before noise binsize : %u",binsize));

   z2=PR_Now();

    addNoise(databin,binsize);
   z3=PR_Now();
 LOG((" deCode Temps de noise : %lu",z3-z2));

    char * dataUnpuctured;
    PRUint64 unpucturedSize;
 z2=PR_Now();
    unpuncture(databin,binsize,&dataUnpuctured,&unpucturedSize);
  z3=PR_Now();
 LOG((" deCode Temps de unpuncutre : %lu",z3-z2));

   // LOG(("unpsize : %u ",unpucturedSize));
//    PRUint8 i;
//    for(i=0;i<25;i++)
     //   LOG(("data : %d ",dataUnpuctured[i]));


    char * data;
  
    treillis * trei= new treillis(this,dataUnpuctured,unpucturedSize);
    trei->decode(&data);
    delete trei;
    z1=PR_Now();
    
    //LOG((" treillis Time before : %u, after %u, diff :%u message : \n %s",mz,z1,z1-mz,data));
    LOG((" Temps de décodage total : %lu",z1-z));

   // LOG(("We freezz decoding"));
	aData.Assign(data);

    //if (data)
    //    NS_Free(data);
    if (dataUnpuctured)
        NS_Free(dataUnpuctured);
	if (databin)
        NS_Free(databin);
	if (adata)
        NS_Free(adata);
    
    
    LOG(("We stop decoding"));
    return NS_OK;
}

 PRUint16 
 PCC::getID()
 {
     return mID;
 }

/*********************************************************************************
 **   Viterbi classes 
 **
 ********************************************************************************/
position::position(PRUint16 input, position * previous)
{
    mInput = input;
    mPrevious = previous;
    mMemory = 0;
}

position::~position()
{
    NS_Free(mMemory);
    mPrevious=0;
}

nsresult
position::copyMemory(PRUint32 *aMemory, PRUint8 aLength)
{
    mMemory= (PRUint32 *) NS_Alloc(sizeof(PRUint32) * aLength);
    if (!mMemory)
        return NS_ERROR_OUT_OF_MEMORY;
    PRUint8 i=0;
    for(i=0;i<aLength;i++)
        mMemory[i]=aMemory[i];
    return NS_OK;
}

void
position::deletePosition()
{
    NS_Free(mMemory);
    mPrevious=0;
}

void
position::setPrevious(position * aPrevious)
{
    mPrevious=aPrevious;
}

PRUint32 * position::getMemory()
{
    return mMemory;
}

position *
position::getPrevious()
{
    return mPrevious;
}

PRUint16
position::getInput()
{
    return mInput;
}
/*********************************************************************************
 *
 *
 ********************************************************************************/


noded::noded(PRInt8 metric, PRUint32 positionNumber, position ** block)
{
    mMetric = metric;
    mPositionNumber = positionNumber;
    mBlock = block;
}

noded::~noded()
{
    PRUint32 i;
    for(i=0;i<mPositionNumber;i++)
        mBlock[i]->deletePosition();
	NS_Free(mBlock);
}

void
noded::setMetric(PRInt8 aMetric)
{
    mMetric = aMetric;
}

PRInt8 
noded::getMetric()
{
    return mMetric;
}

void
noded::addPosition(PRInt8 aMetric,PRUint16 aInput,PRUint32 *aMemory, PRUint8 aMemoryLength, position *aPrevious)
{
    mPositionNumber++;
    mBlock= (position **) NS_Realloc((void *)mBlock,sizeof(position*)*mPositionNumber);
    position * p = new position(aInput, aPrevious);
    p->copyMemory(aMemory, aMemoryLength); 
    mBlock[mPositionNumber-1]=p;
    mMetric=aMetric;
}

void
noded::replaceBlock(PRInt8 aMetric,PRUint16 aInput,PRUint32 *aMemory, PRUint8 aMemoryLength, position *aPrevious)
{
    PRUint32 i;
    for(i=0;i<mPositionNumber;i++)
        mBlock[i]->deletePosition();
    mPositionNumber=1;
    mBlock= (position **) NS_Alloc(sizeof(position*));
    position * p=new position(aInput,aPrevious);
    p->copyMemory(aMemory, aMemoryLength); 
    mBlock[mPositionNumber-1]=p;
    mMetric=aMetric;
}

PRBool
noded::isEmpty()
{
    if(mPositionNumber)
        return PR_FALSE;
    return PR_TRUE;
}

PRUint32 
noded::getPositionNumber()
{
    return mPositionNumber;
}

PRUint32 * 
noded::getMemory(PRUint32 aPosition)
{
    return mBlock[aPosition]->getMemory();
}

position * 
noded::getAddressPosition(PRUint32 aPosition)
{
    return mBlock[aPosition]; 
}

/*********************************************************************************
 *
 *
 ********************************************************************************/


treillis::treillis(PCC *aPcc,char * aData, PRUint64 aLength)
{
    mPcc = aPcc;
    mData=aData;
    mDataLength=aLength;
    PRUint64 i;
    PRUint16 j;
    mHeight=1<<(mPcc->mN);
    mWidth=(PRUint64) floor((double)(mDataLength/(mPcc->mN)));
    mTreillis = (noded ***) NS_Alloc(sizeof(noded**)*mWidth+1);
    //LOG(("mWidth : %u, mHeight : %u ", mWidth, mHeight));
    for(i=0;i<mWidth+1;i++) {
        mTreillis[i] = (noded **) NS_Alloc(sizeof(noded*) * (mHeight));
        for(j=0;j<mHeight;j++) { 
            mTreillis[i][j] = 0;
        }

    }
}

treillis::~treillis()
{
    LOG(("[Perseus Extension][treillis::~treillis()] \
            mTreillis delete..."));
	PRUint16 i, j;
    for(i=0;i<mWidth;i++) {
        for(j=0;j<mHeight;j++)  
            delete mTreillis[i][j];
        NS_Free(mTreillis[i]);
    }
    //NS_Free(mTreillis);
}

void
treillis::setMetric(PRUint64 x, PRUint16 y, PRInt8 aMetric)
{
    mTreillis[x][y]->setMetric(aMetric);
}

PRInt8 
treillis::getMetric(PRUint64 x, PRUint16 y)
{
    return mTreillis[x][y]->getMetric();
}

PRBool
treillis::isEmpty(PRUint64 x, PRUint16 y)
{
    return (mTreillis[x][y]==0);
}

PRUint32
treillis::NumberOfPosition(PRUint64 x, PRUint16 y)
{
   //LOG(("number of position : %lu",mTreillis[x][y]->getPositionNumber()));
    return mTreillis[x][y]->getPositionNumber();
}

PRUint32 *
treillis::getMemory(PRUint64 x, PRUint16 y, PRUint32 aPosition)
{
    return mTreillis[x][y]->getMemory(aPosition);
}

position *
treillis::getAddressPosition(PRUint64 x, PRUint16 y, PRUint32 aPosition)
{
    return mTreillis[x][y]->getAddressPosition(aPosition);
}

void
treillis::addPosition(PRUint64 x, PRUint16 y, 
        PRInt8 aMetric,PRUint16 aInput,
        PRUint32 *aMemory, PRUint8 aMemoryLength,
        position *aPrevious)
{
//LOG(("add position x: %u, y:%u input : %u metric : %d",x,y,aInput,aMetric));
    if (!mTreillis[x][y]) {
        mTreillis[x][y]= new noded(0,0,0);
        mTreillis[x][y]->addPosition(aMetric,aInput,aMemory,aMemoryLength, aPrevious);
    } else {
        if (getMetric(x,y)>aMetric)
            mTreillis[x][y]->replaceBlock(aMetric,aInput,aMemory,aMemoryLength, aPrevious);
        else {
            if (getMetric(x,y)==aMetric || NumberOfPosition(x,y)==0)
                mTreillis[x][y]->addPosition(aMetric,aInput,aMemory,aMemoryLength, aPrevious);
            // else  do nothing
        }
    }
}

PRUint8
distance(const char * a, PRUint16 b, PRUint8 length, PRUint64 begin)
{
    PRUint8 i, dist=0;
    for(i=0;i<length;i++) {
        if (a[begin] != 0xF) 
            dist+=(a[begin]&0x1) ^ (b>>(length-1-i) &0x01);
        begin++;
    }
    return dist;
}

void
treillis::backward(char ** aDataDecoded)
{
  //LOG(("backward treillis"));

    //Search the minus
    PRInt8 minMetric=-1, metric;
    PRUint16 j, min=(1<<16)-1;
    //LOG(("mWidth : %u",mWidth));
    for(j=0;j<mHeight;++j) {
        if (! isEmpty(mWidth,j)) {
        //LOG(("j : %u ",j));
        metric=getMetric(mWidth,j);
         //LOG(("j : %u , metric : %d",j,metric));
        if ( (metric<minMetric) || (minMetric == -1) ) {
            //LOG((" found j : %u , metric : %d",j,metric));

            min=j;
            minMetric=metric; 
            }
        }
    }
  //LOG(("min : %u minmetric : %d",min, minMetric));

    if(isEmpty(mWidth,min)) {
        //LOG(("a Serious Problem : min : %u",min));
        return;
    }
    //LOG(("We must be a 1; number of node : %u min : %d",mTreillis[mWidth][min]->getPositionNumber(),min));
    
    position * tmp=getAddressPosition(mWidth,min,0);
    PRUint64 i=mWidth;
    PRUint32 *table = (PRUint32 *) NS_Alloc(sizeof(PRUint32)*mWidth);

    while(tmp && i>0) {
        i--;
        table[i] = tmp->getInput();
        //LOG((" table[%llu]=%lu",i,table[i]));

        tmp=tmp->getPrevious();
    }

    *aDataDecoded=int_to_char(table,mWidth,mPcc->mK);
    //LOG((" data fin : %s ",*aDataDecoded));

    NS_Free(table);
}

void
treillis::decode(char ** aDataDecoded)
{
    PRUint8 MaxMetric=0;
    PRUint32 *nextmemory=(PRUint32 *) PR_Calloc(sizeof(PRUint32),mPcc->mK);
    addPosition(0,0,0,0,nextmemory,mPcc->mK,0);
    PRUint32 bitmask=0;
    PRUint32 positionNumber;
    PRUint8 abit;
    PRUint16 input;
    PRUint16 value=0;
    PRUint16 valueFin=0;
    PRUint32 *memory;
    PRUint64 i;
    PRUint16 j;
    PRUint8 k;
    PRUint32 m;
    PRUint16 n_bit;
    PRUint8 tmpdist;
    for(i=0;i<mPcc->mM;++i) {
        bitmask <<= 1;
        bitmask |= 1;
    }
    for(i=0;i<mWidth;i++) {
        for(j=0;j<mHeight;++j) {
            if (isEmpty(i,j))
                continue;
            positionNumber=NumberOfPosition(i,j);

            for(m=0;m<positionNumber;m++) {
                memory = getMemory(i,j,m);
                for(input=0;input<(1<<(mPcc->mK));++input) {
                    valueFin=0;
                    for(k=0;k<mPcc->mK;++k) {
                        abit=input>>k & 0x1;
                        mPcc->compute((mPcc->mPoly)[k],abit,memory[k],&value);
                        valueFin^=value;
                        nextmemory[k] = (memory[k]<<1 | abit) & bitmask;
                        value=0;
                    }
                    n_bit=i*mPcc->mN;
                    tmpdist=distance(mData,valueFin,mPcc->mN,n_bit);
                   
                    tmpdist+=getMetric(i,j);
                    if (tmpdist<=MaxMetric)
                        addPosition(i+1,valueFin,tmpdist,input,nextmemory,mPcc->mK,getAddressPosition(i,j,m));
                }
            }
        }
    }

    backward(aDataDecoded);
}



/*****************************************************************************\
 ***   nsPerseusCode class, manage the Hash Table.
 ***   The table maps a host to Pcc parameters
 ***    http://www.mozilla.org/projects/nspr/reference/html/plhash.html
 ******************************************************************************/

static void *
DefaultAllocTable(void *pool, PRSize size)
{
    return NS_Alloc(size);
}

static void
DefaultFreeTable(void *pool, void *item)
{
    NS_Free(item);
}

static PLHashEntry *
DefaultAllocEntry(void *pool, const void *key)
{
    return PR_NEW(PLHashEntry);
}

static void
PCCFreeEntry(void *pool, PLHashEntry *he, PRUintn flag)
{
    LOG(("[nsPerseusCode:PCCFreeEntry] : We delete a table entry!"));

    if (flag == HT_FREE_ENTRY) {
        PCC* entry = reinterpret_cast<PCC*>(he->value);
        delete entry;
        NS_Free(he);
    }
}


const static PLHashAllocOps HashAllocOps = 
{
    DefaultAllocTable, DefaultFreeTable,
    DefaultAllocEntry, PCCFreeEntry
};

nsPerseusCode::nsPerseusCode()
{
    LOG(("[Perseus Extension][nsPerseusCode::nsPerseusCode] \
            Hash Table is created"));
	mLock = PR_NewLock();
	if (mLock == NULL) {
		LOG(("[Perseus Extension][nsPerseusCode::nsPerseusCode] \
            Lock is created"));
	}

	PR_Lock(mLock);
    mTable = PL_NewHashTable(48, PL_HashString,
            PL_CompareStrings,PL_CompareStrings,&HashAllocOps,0);

	PR_Unlock(mLock);
}

nsPerseusCode::~nsPerseusCode()
{
    LOG(("[Perseus Extension][nsPerseusCode::~nsPerseusCode] \
            Detruction of the Hash Table"));
	PR_Lock(mLock);
	PL_HashTableDestroy(mTable);
	PR_Unlock(mLock);

	PR_DestroyLock(mLock);
}

/*
 * hasAcode return true, if host has already pcc parameters
 */
PRBool
nsPerseusCode::hasACode(const nsACString& host)
{
    LOG((" [Perseus Extension] - [nsPerseusCode::hasAcode] "));
    char * hostChar= ToNewCString(host);
    PRBool ok;
void * p;

	if (!hostChar) {
		ok = PR_FALSE;
        goto end;
	}
    PR_Lock(mLock);
	p = PL_HashTableLookup(mTable,hostChar);
	PR_Unlock(mLock);

	if (p) {
        ok = PR_TRUE;
	} else {  
        ok = PR_FALSE;
	}
	 
	NS_Free(hostChar);
end:
	return ok;
}

PRBool 
nsPerseusCode::deleteAcode(const nsACString &host)
{
    char * hostChar= ToNewCString(host);
    PRBool ok;

	if (!hostChar) {
        ok = PR_FALSE;
		goto end;
	}
	PR_Lock(mLock);
    ok=PL_HashTableRemove(mTable,hostChar);
	PR_Unlock(mLock);

	NS_Free(hostChar);
end:
	return ok;
}

PRUint16
nsPerseusCode::getID(const nsACString &host)
{
    char * hostChar= ToNewCString(host);
	PRUint16 id;
	void * p;
	PCC *tmppcc;
	if (!hostChar) {
        id = 0;
		goto end;
	}

	PR_Lock(mLock);

        p=PL_HashTableLookup(mTable,hostChar);
    
	PR_Unlock(mLock);

        LOG(("[Perseus Extension] - "
             "[nsPerseusCode::code] GetID"));

    if (p) {
        tmppcc=( PCC *) p;
        LOG(("[Perseus Extension] - "
             "[nsPerseusCode::code]  PCC Code"));
        id=tmppcc->getID();
    }
	

//end1:
	NS_Free(hostChar);
end:
    return id;
}

nsresult 
nsPerseusCode::createAcode(const nsACString &host)
{
    nsresult rv;
    PLHashEntry * entry;    

if (hasACode(host)) {
        deleteAcode(host);
    } 
	/*
	PUNCT_CONC_CODE * pcc;
	int Gen_PCC(PUNCT_CONC_CODE * pcc);
	NOISE_GEN * noiser;
	INIT_NOISE_GEN * noiser_init;
	int Gen_Noise_Generator(NOISE_GEN *, INIT_NOISE_GEN *);
	Save pcc, noiser and noiser_init in the hash table
	*/
    
	PCC * Pcc= new PCC();
    rv=Pcc->generateCode();
    NS_ENSURE_SUCCESS(rv, rv);
    
	char * hostChar= ToNewCString(host);
    
	if (!hostChar) {
        rv = NS_ERROR_FAILURE;
		goto end;
	}
    LOG((" [Perseus Extension] - [nsPerseusCode::createAcode] \
		 Add in Hash Table : %lu, host : %s",mTable,hostChar));

	
	PR_Lock(mLock);

        entry =PL_HashTableAdd(mTable,hostChar,Pcc);

	PR_Unlock(mLock);

	if (!entry) {
        rv = NS_ERROR_FAILURE;
		goto end1;
	}
    
    rv = NS_OK;

end1:
	NS_Free(hostChar);
end:
	return rv;
}

char * 
nsPerseusCode::toString(const nsACString &host)
{

	LOG(("[Perseus Extension] - "
          "[PerseusCode::toString] Begin"));
    char * parameters = nsnull;
	char * hostChar= ToNewCString(host);
	void * p;
	PCC *tmppcc;

	if (!hostChar) {
        goto end;
	}

	LOG(("[Perseus Extension] - "
         " [PerseusCode::toString] search : %s in %lu",hostChar,mTable));
    
	PR_Lock(mLock);
	p=PL_HashTableLookup(mTable,hostChar);
	PR_Unlock(mLock);
	
	if (p) {
		LOG(("[Perseus Extension] - \
			 [nsPerseusCode::toString] A Value found for the key"));
		tmppcc=( PCC *) p;
		parameters = tmppcc->toString();
		LOG(("[Perseus Extension] - "
			"[PerseusCode::toString] Parameters  : %s",parameters));
	}


//end1:
	NS_Free(hostChar);
end:
	return parameters;

}

nsresult 
nsPerseusCode::code(const nsACString& host,
				    const nsACString & aData,
					PRUint64 aLength,
					nsACString & aDataCoded)
{
    nsresult rv;
    LOG(("[Perseus Extension] - \
                [nsPerseusCode::code]"));
    char * hostChar= ToNewCString(host);
    void * p;
    PCC *tmppcc;

	if (!hostChar) {
		rv = NS_ERROR_FAILURE;
		goto end;
	}
    
	PR_Lock(mLock);

        p=PL_HashTableLookup(mTable,hostChar);
	
	PR_Unlock(mLock);

	LOG(("[Perseus Extension] - \
		 [nsPerseusCode::code] Get Value in hash table OK : Host : %s",hostChar));
    
    if(p) {
		LOG(("[Perseus Extension] - \
			 [nsPerseusCode::code] A Value found for the key"));
		tmppcc= (PCC *) p;
     	/* We retrieve in the hash table: 
		PUNCT_CONC_CODE * pcc;
		NOISE_GEN * noiser;
		INIT_NOISE_GEN * noiser_init;
		Code :
		int PCC_Encode(unsigned char*, unsigned char *, 
				PUNCT_CONC_CODE *, unsigned long int);
		Add Noise :
		int Gen_Noise(unsigned char*, NOISE_GEN *,
				unsigned long int, INIT_NOISE_GEN *);
		*/
        rv=tmppcc->code(aData,aLength,aDataCoded);
    }
	else {
		LOG(("[Perseus Extension] - "
		     "[nsPerseusCode::code] No Value for this key : %s",hostChar));
		rv = NS_ERROR_FAILURE;
	}

	
//end1:
	NS_Free(hostChar);
end:
	return rv;;
}

nsresult 
nsPerseusCode::decode(	const nsACString& host,
						const nsACString & aDataCoded,
							  PRUint64 aLength,
							  nsACString & aData)
{
	nsresult rv;  
	char * hostChar= ToNewCString(host);
        PCC *tmppcc;
	void * p;

	if (!hostChar) {
		rv = NS_ERROR_FAILURE;
		goto end;
	}
    
	PR_Lock(mLock);
	p=PL_HashTableLookup(mTable,hostChar);
    	PR_Unlock(mLock);

    if(p) {
        tmppcc=( PCC *) p;
		/* We retrieve in the hash table: 
		PUNCT_CONC_CODE * pcc;
		NOISE_GEN * noiser;
		INIT_NOISE_GEN * noiser_init;
		Del Noise :
		int Gen_Noise(unsigned char*, NOISE_GEN *,
				unsigned long int, INIT_NOISE_GEN *);
		DeCode :
		int Viterbi_Decode(unsigned char*, unsigned char *, 
				PUNCT_CONC_CODE *, unsigned long int);
		*/
        tmppcc->decode(aDataCoded,aLength,aData);
        rv = NS_OK;
    }
	else {
		rv = NS_ERROR_FAILURE;
	}
end1:
	NS_Free(hostChar);
end:
	return rv;
}
